<?php
/**
 * Created by PhpStorm.
 * User: rafaelrapalo
 * Date: 29/05/14
 * Time: 10:33
 */

namespace Factory;

use Service\Calendar\Restriction\Strategy\RestrictionFactory;
use Zeedhi\DevOps\Model\Projectmanagement\Entities;
use Zeedhi\DevOps\Model\Devops\Entities as DevopsEntities;

class Project {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager){
        $this->entityManager = $entityManager;
    }

    public function createProject(  $name, $parent, $status, $duration, $endDate, $beginDate, $group, $dateExceptionType,
                                    $dateException, $description = '', $isBoard = 'N', $projectType = null, $category = null,
                                    Entities\TaskStatus $projectStatus = null, DevopsEntities\ProductVersion $productVersion = NULL,
                                    $isLtsReplication = 'Y'){

        $entity = new Entities\Project();
        $entity->setName($name);
        $entity->setStructure($group);
        $entity->setStatus($status);
        $entity->setParent($parent);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setDuration($duration);
        $entity->setDateException($dateException);
        $entity->setDateExceptionType($dateExceptionType);
        $entity->setDescription($description);
        $entity->setIsIssueProject($isBoard);
        $entity->setClassification($category);
        $entity->setProjectType($projectType);
        $entity->setProjectStatus($projectStatus);
        $entity->setProductVersion($productVersion);
        $entity->setIsLtsReplication($isLtsReplication);
        return $entity;
    }

 public function updateProject(  Entities\Project $entity, $name, $beginDate, $endDate, $status, $structure, $parent,
                                    $duration, $dateExceptionType = 'MB', $dateException, $description = '',Entities\ProjectType $projectType = null,
                                     $category = null,$projectStatus = null, $productVersion = null, $isLtsReplication = null
    ){
        $entity->setName($name);
        $entity->setStructure($structure);
        $entity->setStatus($status);
        $entity->setParent($parent);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setDuration($duration);
        $entity->setDateExceptionType($dateExceptionType);
        $entity->setDateException($dateException);
        $entity->setDescription($description);
        $entity->setProjectType($projectType);
        $entity->setClassification($category);
        $entity->setProjectStatus($projectStatus);
        $entity->setProductVersion($productVersion);
        $entity->setIsLtsReplication($isLtsReplication);
        return $entity;
    }

    public function updateProjectStatus(Entities\TaskStatus $entity, $label, $generatesLog,
                                        $taskCanStart,$control = null){
        $entity->setLabel($label);
        $entity->setGeneratesLog($generatesLog);
        $entity->setTaskCanStart($taskCanStart);
        $entity->setIsProject('Y');
        $entity->setIsTask('N');
        $entity->setIsIssue('N');
        $entity->setControl($control);
        return $entity;
    }

    public function createProjectStatus($statusLabel, $generatesLog, $taskCanStart,$control = null){
        $entity = new Entities\TaskStatus();
        $entity->setLabel($statusLabel);
        $entity->setIsProject('Y');
        $entity->setIsTask('N');
        $entity->setIsIssue('N');
        $entity->setGeneratesLog($generatesLog);
        $entity->setTaskCanStart($taskCanStart);
        $entity->setControl($control);
        return $entity;
    }
    public function createMeetingOccurrences($name, $parent, $status, $duration, $endDate, $beginDate, $group,
                                          $dateExceptionType, $dateException, $projectType,
                                          Entities\TaskStatus $projectStatus){

        $entity = new Entities\Project();
        $entity->setName($name);
        $entity->setStructure($group);
        $entity->setStatus($status);
        $entity->setParent($parent);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setDuration($duration);
        $entity->setDateException($dateException);
        $entity->setDateExceptionType($dateExceptionType);
        $entity->setIsIssueProject('N');
        $entity->setProjectType($projectType);
        $entity->setProjectStatus($projectStatus);
        return $entity;
    }
    public function createMeeting($name, $status, $duration, $endDate, $beginDate, $group, $projectType,
                                  Entities\TaskStatus $projectStatus,$description){

        $entity = new Entities\Project();
        $entity->setName($name);
        $entity->setStructure($group);
        $entity->setStatus($status);
        $entity->setBeginDate($beginDate);
        $entity->setEndDate($endDate);
        $entity->setDuration($duration);
        $entity->setDateException($beginDate);
        $entity->setDateExceptionType(RestrictionFactory::SHOULD_START);
        $entity->setIsIssueProject('N');
        $entity->setProjectType($projectType);
        $entity->setProjectStatus($projectStatus);
        $entity->setDescription($description);
        return $entity;
    }

}
