<?php
/**
 * Created by PhpStorm.
 * User: eugeniofonseca
 */

namespace Service;


class Available {

    protected  $entityManager;
    protected  $availableFactory;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager, \Factory\Available $availableFactory){
        $this->entityManager = $entityManager;
        $this->availableFactory = $availableFactory;
    }

    public function createAvailable($begin, $end, $resource) {
        $begin = str_replace('/', '-', $begin);
        $end = str_replace('/', '-', $end);
        $entity = $this->availableFactory->createAvailable(new \DateTime($begin), new \DateTime($end), $resource);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }
    public function updateAvailable($id, $begin, $end, $resource) {
        $begin = str_replace('/', '-', $begin);
        $end = str_replace('/', '-', $end);
        $entity = $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Available', $id);
        $entity = $this->availableFactory->updateAvailable($entity, new \DateTime($begin), new \DateTime($end), $resource);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }
    public function deleteAvailable($param) {
        foreach($param as $availability){
            $avail = $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Available',$availability['ID']);
            $this->entityManager->remove($avail);
            $this->entityManager->flush();
        }
    }
    public function editResourceAvailability($param){
        $resource = $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource',$param['RESOURCE']);
        $avail = $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\Available',$param['ID']);
        $user= $this->entityManager->find('\Zeedhi\DevOps\Model\Projectmanagement\Entities\BusinessPartner',$param['USER']);
        $param = array(
            'BEGIN'     => new \DateTime($param['SINCE']),
            'END'       => new \DateTime($param['UNTIL']),
            'RESOURCE'  => $resource
        );

        return $this->updateAvailable($param,$avail);
    }
}