<?php
namespace Service;


use Doctrine\ORM\EntityManager;

class Commitment {

    protected  $entityManager;
    protected  $environment;

    public function __construct(EntityManager $entityManager, \Util\Utilities $environment){
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    function createCommitment($param){

        $CommitmentType         = $param['TYPE'];
        $calendar               = $param['CALENDAR'];
        $status                 = $param['STATUS'];
        $beginDate              = \DateTime::createFromFormat('d/m/Y',$param['BEGIN_DATE']);
        $endDate                = \DateTime::createFromFormat('d/m/Y',$param['END_DATE']);
        $name                   = $param['NAME_EXCEPTION'];
        $updatedBy              = $param['UPDATED_BY'];
        $createdBy              = $param['CREATED_BY'];


        $entity = new \Factory\Commitment($this->entityManager);
        $entity = $entity->createCommitment($CommitmentType,$status, $calendar, $beginDate, $endDate, $name, $this->organization, $updatedBy, $createdBy);

        $this->entityManager->persist($entity);
        $this->entityManager->flush();

        return $entity;
    }
    function updateCommitment($entity, $param){

        $CommitmentType         = $param['TYPE'];
        $calendar               = $param['CALENDAR_ENTITY'];
        $status                 = $param['STATUS'];
        $beginDate              = \DateTime::createFromFormat('d/m/Y',$param['BEGIN_DATE']);
        $endDate                = \DateTime::createFromFormat('d/m/Y',$param['END_DATE']);
        $name                   = $param['NAME_EXCEPTION'];
        $updatedBy              = $param['UPDATED_BY'];


        $factoryCommitment = new \Factory\Commitment($this->entityManager);
        $entity = $factoryCommitment->updateCommitment($entity,$CommitmentType,$status, $calendar, $beginDate, $endDate, $name, $updatedBy);

        $this->entityManager->persist($entity);
        $this->entityManager->flush();

        return $entity;
    }


    function createCommitmentException(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar $calendar,\Zeedhi\DevOps\Model\Projectmanagement\Entities\CommitmentType $commitmentType,$name,\DateTime$beginDate,
                                       \DateTime $endDate,$status,$unit,$timeBreak,$beginTimeBreak,$endTimeBreak,$user){

        $entity = new \Factory\Commitment($this->entityManager);
        $entity = $entity->createCommitmentException($calendar,$commitmentType,$name,$beginDate,
            $endDate,$status,$unit,$timeBreak,$beginTimeBreak,$endTimeBreak,$user,$this->environment->getCurrentOrganization());

        $this->entityManager->persist($entity);
        $this->entityManager->flush();

        return $entity;
    }
    function updateCommitmentException(\Zeedhi\DevOps\Model\Projectmanagement\Entities\Commitment $entity ,\Zeedhi\DevOps\Model\Projectmanagement\Entities\Calendar $calendar,\Zeedhi\DevOps\Model\Projectmanagement\Entities\CommitmentType $commitmentType,
                                       $name,\DateTime $beginDate,\DateTime $endDate,$status,$unit,$timeBreak,$beginTimeBreak,
                                       $endTimeBreak,\Zeedhi\DevOps\Model\Projectmanagement\Entities\BusinessPartner $user){


        $entityFactory = new \Factory\Commitment($this->entityManager);
        $entity = $entityFactory->updateCommitmentException($entity,$commitmentType,$status, $calendar, $beginDate,
                    $endDate, $name,$unit,$timeBreak, $beginTimeBreak, $endTimeBreak, $this->environment->getCurrentOrganization(), $user);

        $this->entityManager->persist($entity);
        $this->entityManager->flush();

        return $entity;
    }
} 
