/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_BAIRRO                                                   */
/* Tabela : BAIRRO                                                            */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_BAIRRO' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_BAIRRO
GO

CREATE TRIGGER DTULTATU_BAIRRO
ON BAIRRO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'BAIRRO', null, 'CDPAIS='+ CDPAIS + ';'+
                                     'SGESTADO='+ SGESTADO+ ';'+
                                     'CDMUNICIPIO='+ CDMUNICIPIO+ ';'+
                                     'CDBAIRRO='+ CDBAIRRO+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE BAIRRO
      SET DTULTATUBAIR = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(BAIRRO.CDBAIRRO,0) = ISNULL(INSERTED.CDBAIRRO,0)) AND
            (ISNULL(BAIRRO.NMBAIRRO,0) = ISNULL(INSERTED.NMBAIRRO,0));
   END;
END;
GO

